"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _QueryBuilder = _interopRequireDefault(require("./QueryBuilder"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/**
  * id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL DEFAUL '' +
  */
class ColumnInfo {
  _primaryKey = false;
  _autoIncrement = false;
  _nullable = false;
  constructor(name, type) {
    this.name = name;
    this.type = type;
  }
  primaryKey() {
    this._primaryKey = true;
    return this;
  }
  autoIncrement() {
    this._autoIncrement = true;
    return this;
  }
  defaultVal(defaultVal) {
    this._defaultVal = defaultVal;
    return this;
  }
  nullable() {
    this._nullable = true;
    return this;
  }
  compile() {
    const sql = [`${this.name} ${this.type}`, this._primaryKey ? " PRIMARY KEY" : "", this._autoIncrement ? " AUTOINCREMENT" : "", this._nullable ? " NULL" : " NOT NULL", this._defaultVal != null ? ` DEFAULT ${_QueryBuilder.default.escapeSqlString(this._defaultVal)}` : ""];
    return sql.join("");
  }
}
exports.default = ColumnInfo;
//# sourceMappingURL=ColumnInfo.js.map