import QueryBuilder from "./QueryBuilder";

/**
  * id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL DEFAUL '' +
  */
export default class ColumnInfo {
  _primaryKey = false;
  _autoIncrement = false;
  _nullable = false;
  constructor(name, type) {
    this.name = name;
    this.type = type;
  }
  primaryKey() {
    this._primaryKey = true;
    return this;
  }
  autoIncrement() {
    this._autoIncrement = true;
    return this;
  }
  defaultVal(defaultVal) {
    this._defaultVal = defaultVal;
    return this;
  }
  nullable() {
    this._nullable = true;
    return this;
  }
  compile() {
    const sql = [`${this.name} ${this.type}`, this._primaryKey ? " PRIMARY KEY" : "", this._autoIncrement ? " AUTOINCREMENT" : "", this._nullable ? " NULL" : " NOT NULL", this._defaultVal != null ? ` DEFAULT ${QueryBuilder.escapeSqlString(this._defaultVal)}` : ""];
    return sql.join("");
  }
}
//# sourceMappingURL=ColumnInfo.js.map